#pragma once
#include <iostream>
#include <cstring>

template<class T>
void to_bin(T v)
{
  union
  {
      T value;
      unsigned char bytes[sizeof(T)];
  };
  memset(&bytes, 0, sizeof(T));
  value = v;
  // assumes little endian machine 
  for (size_t i = sizeof(T);i>0;i--)
  {
    unsigned char pot=128;
    for (int j = 7;j>=0;j--,pot/=2) 
      if (bytes[i-1]&pot) 
        std::cout << "1";
      else 
        std::cout << "0";
    std::cout << " ";
  }
  std::cout << std::endl;
}
